!function(e){"object"==typeof exports?module.exports=e():"function"==typeof define&&define.amd?define(e):"undefined"!=typeof window?window.log=e():"undefined"!=typeof global?global.log=e():"undefined"!=typeof self&&(self.log=e())}(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);throw new Error("Cannot find module '"+o+"'")}var f=n[o]={exports:{}};t[o][0].call(f.exports,function(e){var n=t[o][1][e];return s(n?n:e)},f,f.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({
	1: [function(require, module, exports) {
		var MemStore = function() {
			this.events = [];
		};

		MemStore.prototype.append = function(event) {
			this.events.push(event);
		};

		MemStore.prototype.clear = function() {
			this.events = [];
		};

		MemStore.prototype.getEvents = function() {
			return this.events;
		};

		module.exports = MemStore;
	}, {}],
	2: [function(require, module, exports) {

		function initialize() {
			saveIndex({first: 0, next: 0});
		}

		function saveIndex(index) {
			try {
				localStorage.log = JSON.stringify(index);
			} catch (ex) {}
		}

		function loadIndex() {
			try {
				return JSON.parse(localStorage.log);
			} catch (ex) {
				return {first: 0, next: 0};
			}
		}

		function foreachKey(cb, startId) {
			var index = loadIndex();
			startId = startId || index.first;

			while (startId < index.next) {
				cb('log' + startId++);
			}
		}

		var LocalStore = function(opts) {
			opts = opts || {};
			this.maxSize = opts.maxSize || 500;

			if (typeof localStorage.log === 'undefined') {
				initialize();
			}
		};

		LocalStore.prototype.clear = function() {
			foreachKey(function(key) {
				delete localStorage[key];
			});
			initialize();
		};

		LocalStore.prototype.purgeOldEvents = function() {
			var index = loadIndex();
			var toPurge = index.first + Math.round(this.maxSize / 3);

			while (index.first < toPurge) {
				delete localStorage['log' + index.first++];
			}
			saveIndex(index);
		};

		LocalStore.prototype.getNext = function() {
			return loadIndex().next;
		};

		LocalStore.prototype.getEvents = function(startId) {
			var events = [];
			foreachKey(function(key) {
				try {
					events.push(JSON.parse(localStorage[key]));
				} catch (ex) {}
			}, startId);
			return events;
		};

		LocalStore.prototype.append = function(event) {
			var index = loadIndex();
			var currentSize = index.next - index.first;
			if (currentSize >= this.maxSize) {
				this.purgeOldEvents();
				index = loadIndex();
			}

			var key = 'log' + index.next;
			try {
				try {
					localStorage[key] = JSON.stringify(event);
				} catch (ex) {
					this.purgeOldEvents();
					index = loadIndex();

					key = 'log' + index.next;
					localStorage[key] = JSON.stringify(event);
				}
				++index.next;
				saveIndex(index);
			} catch (ex2) {
				console.warn("WARNING: OUT OF LOCALSTORAGE!");
			}
		};

		LocalStore.prototype.upgrade = function() {
			if (!localStorage['plog-index']) {
				return;
			}
			try {
				var index = JSON.parse(localStorage['plog-index']);
				delete localStorage['plog-index'];
				localStorage.log = JSON.stringify({
					first: index.firstId,
					next: index.nextId
				});

				for (var i = index.firstId; i < index.nextId; ++i) {
					var event = JSON.parse(localStorage['plog-event-' + i]);
					delete localStorage['plog-event-' + i];
					localStorage['log' + i] = JSON.stringify([event.level, event.date, event.message]);
				}
			} catch (ex) {}
		};

		module.exports = LocalStore;
	}, {}],
	3: [function(require, module, exports) {
		var RelayStore = function() {};

		RelayStore.prototype.append = function(event) {
			event[1] = event[1].getTime();
			window.postMessage({method: 'log', event: event}, location.origin);
		};

		RelayStore.prototype.clear = function() {}

		RelayStore.prototype.getEvents = function() {
			return [];
		};

		module.exports = RelayStore;
	}, {}],
	4: [function(require, module, exports) {
		var DBStore = function(opts) {
			opts = opts || {};
			opts.size = opts.size || 80;

			this.db = null;
			function createDB(opts) {
				const that = this;
				try {
					this.db = openDatabase("plog", "1.0", "Persistent Log", opts.size * 1024 * 1024);
				} catch (err) {
					opts._retry = (opts._retry || 0) + 1;
					//console.error("LOG RETRY #"+opts._retry);
					if (opts._retry < 100) {
						setTimeout(createDB.bind(that, opts), 50);
					} else {
						console.warn("WARNING: COULDN'T CREATE DATABASE FOR LOGGING! " + err.message)
						localStorage.statSessionLogErr = Number(localStorage.statSessionLogErr || 0) + 1
						localStorage.statTotalLogErr = Number(localStorage.statTotalLogErr || 0) + 1
					}
				}

				this.db && this.db.transaction(function(tx) {
					tx.executeSql('CREATE TABLE IF NOT EXISTS plog (id INTEGER PRIMARY KEY, level INTEGER, date DATETIME, message)');
					tx.executeSql('SELECT max(id) AS last FROM plog', [], function(t, res) {
						localStorage.plogNext = res.rows.item(0).last + 1;
					});
				}, function(err) {
					opts._retry = (opts._retry || 0) + 1;
					//console.error("LOG RETRY #"+opts._retry);
					if (opts._retry < 100) {
						setTimeout(createDB.bind(that, opts), 50);
					} else {
						console.warn("WARNING: COULDN'T CREATE DATABASE FOR LOGGING! " + err.message)
						localStorage.statSessionLogErr = Number(localStorage.statSessionLogErr || 0) + 1
						localStorage.statTotalLogErr = Number(localStorage.statTotalLogErr || 0) + 1
					}
				});
			}
			createDB.call(this, opts);
		};

		DBStore.prototype.upgrade = function() {
			if (!localStorage.log) {
				return;
			}
			try {
				this.db && this.db.transaction(function(tx) {
					var index = JSON.parse(localStorage.log);
					delete localStorage.log;

					for (var i = index.first; i < index.next; ++i) {
						var event = JSON.parse(localStorage['log' + i]);
						delete localStorage['log' + i];

						tx.executeSql('INSERT INTO plog (level, date, message) VALUES (?, ?, ?)', [event[0], new Date(event[1]).getTime(), event[2]]);
					}
					tx.executeSql('SELECT max(id) AS last FROM plog', [], function(t, res) {
						localStorage.plogNext = res.rows.item(0).last + 1;
					});
				});
			} catch (ex) {}
		};

		DBStore.prototype.append = function(event) {
			const that = this;
			try {
				this.db && this.db.transaction(function(tx) {
					tx.executeSql('INSERT INTO plog (level, date, message) VALUES (?, ?, ?)', [event[0], event[1].getTime ? event[1].getTime() : event[1], event[2]], function(t, res) {
						//if (res.insertId >= (localStorage.plogNext || 1)) {
						localStorage.plogNext = res.insertId + 1;
						//}
					});
				}, function(err) {
					event._retry = (event._retry || 0) + 1;
					//console.error("LOG RETRY #"+event._retry);
					if (event._retry < 100) {
						setTimeout(DBStore.prototype.append.bind(that, event), 50);
					} else {
						console.error("Error writing log entry to DB: " + err.message)
						localStorage.statSessionLogErr = Number(localStorage.statSessionLogErr || 0) + 1
						localStorage.statTotalLogErr = Number(localStorage.statTotalLogErr || 0) + 1
					}
				});
			} catch (ex) {}
		};

		DBStore.prototype.clear = function() {
			try {
				this.db && this.db.transaction(function(tx) {
					tx.executeSql('DELETE FROM plog', [], function() {
						localStorage.plogNext = 1;
					});
				});
			} catch (ex) {}
		};

		DBStore.prototype.purgeBefore = function(date) {
			try {
				this.db && this.db.transaction(function(tx) {
					tx.executeSql('DELETE FROM plog WHERE date < ?', [date.getTime ? date.getTime() : date]);
					tx.executeSql('SELECT max(id) AS last FROM plog', [], function(t, res) {
						localStorage.plogNext = res.rows.item(0).last + 1;
					});
				});
			} catch (ex) {}
		};

		DBStore.prototype.getNext = function() {
			return localStorage.plogNext || 1;
		};

		DBStore.prototype.getEvents = function() {
			return [];
		};

		DBStore.prototype.getEventsCB = function(cb, startId, limit, doSort) {
			try {
				this.db && this.db.readTransaction(function(tx) {
					tx.executeSql("SELECT * FROM plog WHERE id >= ?" + (doSort ? " ORDER BY date" : "") + (limit ? " LIMIT " + limit : ""), [startId || 0], function(t, res) {
						cb(res.rows);
					});
				});
			} catch (ex) {}
		};

		module.exports = DBStore;
	}, {}],
	5: [function(require, module, exports) {
		var log = {};

		log.store = {
			LocalStore: require('./LocalStore'),
			MemStore: require('./MemStore'),
			RelayStore: require('./RelayStore'),
			DBStore: require('./DBStore'),
		};

		log.level = {
			DEBUG: 0,
			INFO: 1,
			WARN: 2,
			ERROR: 3,
			FATAL: 4,
			NOTICE: 5,
			SUCCESS: 6
		};
		log.levelName = [];

		var currentStore, currentLevel;

		log.reset = function() {
			const isBG = chrome.extension && chrome.extension.getBackgroundPage() === window
			currentStore = isBG ? new log.store.DBStore() : new log.store.RelayStore();
			currentLevel = isBG ? log.level.INFO : log.level.DEBUG;
		};

		log.reset();

		log.useStore = function(store) {
			currentStore = store;
		};

		log.getStore = function() {
			return currentStore;
		};

		log.upgrade = function() {
			if (currentStore && currentStore.upgrade) {
				currentStore.upgrade();
			}
		};

		log.getLevel = function() {
			return currentLevel;
		};

		log.setLevel = function(level) {
			currentLevel = level;
		};

		function write(level, msg) {
			if (level < currentLevel)
				return;
			var date = new Date();
			currentStore.append([level, date, msg]);

			console.log((date.toISOString().replace('T', ' ').slice(0, -1)) + ': ' + log.levelName[level] + ': ' + msg);
		}

		for (var levelName in log.level) {
			log.levelName.push(levelName);
			const level = log.level[levelName];
			log[levelName.toLowerCase()] = function(msg) {
				write(level, msg);
			};
		}

		module.exports = log;
	}, {
		"./MemStore": 1,
		"./LocalStore": 2,
		"./RelayStore": 3,
		"./DBStore": 4
	}]}, {}, [5])(5)
});
